import 'package:wowit/controllers/wow_connectivity.dart';

mixin OnlineStatusMixin {
  bool _isOnline = true;

  /// Trạng thái online/offline
  ///
  /// Kết nối mạng/ Không kết nối mạng
  bool get isOnline => _isOnline;

  /// Thiết lập trạng thái online/offline và rebuild UI nếu có
  ///
  /// Không nên tự cập nhật thủ công,
  /// hiện tại chức năng này được quản lý bên [WowConnectivity]
  set isOnline(bool isOnline) {
    if (_isOnline == isOnline) return;
    _isOnline = isOnline;
    updateOnlineStatus();
  }

  /// Định nghĩa cách rebuild UI mỗi khi thay đổi trạng thái online/offline nếu có
  void updateOnlineStatus();

  /// Đăng ký kết nối lắng nghe thay đổi trạng thái online/offline
  ///
  /// Cần phải gọi ở init widget để có thể lắng nghe
  void initConnectivity() {
    WowConnectivity().initialise(this);
  }

  /// Hủy đăng ký lắng nghe thay đổi
  ///
  /// Khi dispose widget thì phải gọi nó để đảm bảo ko lỗi
  void disposeConnectivity() {
    WowConnectivity().dispose(this);
  }
}
